<?php

declare(strict_types = 1);

namespace Drupal\fillpdf_comprehensive_mapper\Hook;

use Drupal\Core\Form\FormState;
use Drupal\Core\Hook\Attribute\Hook;
use Drupal\fillpdf_comprehensive_mapper\BulkUpdate;

class FormAlter {

  /**
   * Implements hook_form_FORM_ID_alter for FillPDF Form Edit Form.
   */
  #[Hook('form_fillpdf_form_edit_form_alter')]
  function formFillPdfEditFormAlter(&$form, FormState $form_state) {
    $fid = $form_state->getFormObject()->getEntity()->id();
    $source_form = \Drupal::config('fillpdf_comprehensive_mapper.settings')->get('source_form');
    if ($fid === $source_form) {
      // Add submit handler to update all forms in a batch process.
      // We do not use the "Fool's submit handlers" which do bloody nothing
      // because Drupal is outright ridiculous sometimes, thanks to scottm316
      // ten freaking years ago for explaining this particular ridiculousness.
      // https://www.drupal.org/project/file_entity/issues/2163295#comment-9877575
      // $form['#submit'][] = [BulkUpdate::class, 'initBatch'];
      $form['actions']['submit']['#submit'][] = [BulkUpdate::class, 'initBatch'];
    }
  }

}